#include "DigitalClock.h"
#include "Observable.h"
#include "ClockTimer.h"
#include <iostream>

DigitalClock::DigitalClock(ClockTimer* s){             
   //Upon instantiation, attaches itself to a ClockTimer
   _observable = s;
   _observable->attach(this);
};

DigitalClock::~DigitalClock(){
   //Upon destruction, detaches itself from its ClockTimer
   _observable->detach(this);
   };
   
void DigitalClock::update(Observable* theChangedSubject){
   //If the notification concerns my own subject, redraw my clocks reading
   if(theChangedSubject == _observable)
      draw();
   }; 

void DigitalClock::draw(){
   //Output the data provided by the view to the user  
   int hour =   _observable->getHour();
   int minute = _observable->getMinute();
   int second = _observable->getSecond();
   cout << hour << ':' << minute << ':' << second << endl;
};
